#!/usr/bin/perl
# type: perl pck-rate.pl <tracefile> <node> <granularity>

$infile=$ARGV[0];
$tonode=$ARGV[1];
$granularity=$ARGV[2];

# we compute how many packets were transmitted during time interval
# specified by granularity parameter in seconds

$sum=0;
$clock=0;

open (DATA, "<$infile") 
   || die "Can't open $infile $!";

print STDOUT "Time \t Packet rate (pck/s)\n";

while (<DATA>) 
{ 
  @x = split(' ');
  if($x[1]-$clock <= $granularity)
  {
    if($x[0] eq 'r')
    {
      if($x[3] eq $tonode)
      {
        $sum=$sum+1;
      }
    }
  }
  else
  {
    $throughput=$sum/$granularity;
    print STDOUT "$x[1] $throughput\n";
    $clock=$clock+$granularity;
    $sum=0;
  }
}
$throughput=$sum/$granularity;
print STDOUT "$x[1] $throughput\n";
$clock=$clock+$granularity;
$sum=0;

close DATA;
exit(0);

